#pragma once

#include <functional>

namespace jlog {
    /// A single piece of a logging message, with color code, content, and delimiter
    /// These are strung together to build full logger messages in a flexible manner.
    struct token {
        mcolor::ansiColors::Colors colorCode = mcolor::ansiColors::Colors::FG_DEFAULT;
        std::string content = "";
        std::string delimiter = "[]";
    };

    /// These are helper functions designed to be wrapped around for easier custom logger building.
    std::string toks2msg(std::vector<token> tokens, std::function<std::string(token)>);
    std::string consoleMsgFormatter(token t);
    std::string logfileMsgFormatter(token t);
    std::string toks2consoleMsg(std::vector<token> tokens);
    std::string toks2logfileMsg(std::vector<token> tokens);
}
